%define		extraversion pre4

Name:           mplayer
Version:        1.0
Release:        0.lvn.0.12.%{extraversion}.2
Epoch:          0
Summary:        Movie player playing most video formats and DVDs

Group:          Applications/Multimedia
License:        GPL
URL:            http://mplayerhq.hu/
Source0:        http://www.mplayerhq.hu/MPlayer/releases/MPlayer-%{version}%{?extraversion}.tar.bz2
Source1:        http://www.mplayerhq.hu/MPlayer/Skin/Blue-1.4.tar.bz2
Source3:        mplayer.desktop
Patch0:         MPlayer-0.90pre9-runtimemsg.patch
Patch1:         MPlayer-0.90pre10-redhat.patch
Patch2:         mplayer-1.0pre2-ldconfig.patch
Patch3:         mplayer-0.90-v4l.patch
Patch4:         MPlayer-0.90-playlist.patch
# Fix remote vulnerability in GUI code.
Patch5:		http://www.mplayerhq.hu/MPlayer/patches/vuln04-fix.diff
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

Requires:       libpostproc = %{epoch}:%{version}-%{release}
Requires:       mplayer-fonts >= 0:1.1-0.lvn.2
BuildRequires:  desktop-file-utils
BuildRequires:  SDL-devel
BuildRequires:  freetype-devel >= 0:2.0.9
BuildRequires:  libvorbis-devel, libogg-devel, esound-devel, aalib-devel
BuildRequires:  xvidcore-devel >= 0:0.9.2, arts-devel, libdvdread-devel
BuildRequires:  cdparanoia-devel, libmad-devel, faad2-devel
BuildRequires:  libpng-devel, libdv-devel, lzo-devel, libjpeg-devel
BuildRequires:  libungif-devel, zlib-devel, live-devel, glibc-kernheaders
BuildRequires:  libmatroska-devel >= 0:0.6.3
%{!?_without_alsa:BuildRequires:  alsa-lib-devel}
%{?_without_alsa:BuildConflicts:  alsa-lib-devel}

%{?_with_theora:BuildRequires:	libtheora-devel}

%description
MPlayer is a movie player that plays most MPEG, VOB, AVI, OGG/OGM,
VIVO, ASF/WMA/WMV, QT/MOV/MP4, FLI, RM, NuppelVideo, yuv4mpeg, FILM,
RoQ, and PVA files. You can also use it to watch VCDs, SVCDs, DVDs,
3ivx, RealMedia, and DivX movies.

It supports a wide range of output drivers including X11, XVideo, DGA,
OpenGL, SVGAlib, fbdev, AAlib, DirectFB etc. There are also nice
antialiased shaded subtitles and OSD. 

%package gui
Summary:          GUI for MPlayer
Group:            Applications/Multimedia
Requires:         mplayer = %{epoch}:%{version}-%{release}
BuildRequires:    gtk+-devel

%description gui
This package contains a GUI for MPlayer. The package includes a
the default skin for the GUI.

%package mencoder
Summary:          MPlayer movie encoder
Group:            Applications/Multimedia
BuildRequires:    lame-devel
Requires:	  libpostproc = %{epoch}:%{version}-%{release}
Requires:	  mplayer = %{epoch}:%{version}-%{release}

%description mencoder
This package contains the MPlayer movie encoder. 

%package -n libpostproc
Summary:          MPlayer's video post-processing library
Group:            System Environment/Libraries
Provides:         libpostproc-devel = %{epoch}:%{version}-%{release}

%description -n libpostproc
libpostproc is a video post-processing library from the MPlayer
project.


%prep
%setup -q -n MPlayer-%{version}%{?extraversion}
%patch0 -p1 -b .runtimemsg
%patch1 -p0 -b .redhat
%patch2 -p2 -b .ldconfig
%patch3 -p2 -b .v4l
%patch4 -p1 -b .playlist

%patch5 -p0 -b .vulngui
%build

CFLAGS="$RPM_OPT_FLAGS -ffast-math" ./configure \
  --target=%{_target_platform} \
  --prefix=%{_prefix} \
  --datadir=%{_datadir}/mplayer \
  --confdir=%{_sysconfdir}/mplayer \
  --mandir=%{_mandir} \
  --enable-gui \
  --enable-menu \
  --enable-mencoder \
  --enable-largefiles \
%ifarch %ix86
  --enable-win32 \
  --with-win32libdir=%{_libdir}/win32 \
  --with-reallibdir=%{_libdir}/win32 \
%endif
  --enable-joystick \
  --disable-mpdvdkit \
  --disable-lirc \
  --with-cdparanoiaincdir=%{_includedir}/cdda \
  --enable-libdv \
  --enable-external-faad \
  --enable-live \
  --with-livelibdir=%{_libdir}/live \
  --enable-runtime-cpudetection \
  --enable-shared-pp \
  --enable-i18n \
  --enable-external-matroska \
%{?_without_alsa: --disable-alsa} \
%{?_with_theora: --enable-theora} \
  --disable-termcap \
  --disable-svga \
  --disable-smb

make %{?_smp_mflags}


%install
rm -rf $RPM_BUILD_ROOT
make install DESTDIR=$RPM_BUILD_ROOT
make install -C libavcodec/libpostproc DESTDIR=$RPM_BUILD_ROOT

# Take care of manual pages. These are in multiple languages, and there
# is one common manual page for both mplayer and mencoder.
for l in de en es fr; do
  iconv -f iso-8859-1 -t utf-8 < DOCS/man/$l/mplayer.1 > DOCS/man/mplayer.1.$l.utf8
done
iconv -f iso-8859-2 -t utf-8 < DOCS/man/hu/mplayer.1 > DOCS/man/mplayer.1.hu.utf8
iconv -f iso-8859-2 -t utf-8 < DOCS/man/pl/mplayer.1 > DOCS/man/mplayer.1.pl.utf8
iconv -f gbk -t utf-8 < DOCS/man/zh/mplayer.1 > DOCS/man/mplayer.1.zh_TW.utf8

mkdir -p $RPM_BUILD_ROOT%{_mandir}/man1
install -m 644 DOCS/man/mplayer.1.en.utf8 $RPM_BUILD_ROOT%{_mandir}/man1/mplayer.1
install -m 644 DOCS/man/mplayer.1.en.utf8 $RPM_BUILD_ROOT%{_mandir}/man1/mencoder.1

for l in de es fr hu pl zh_TW; do
  mkdir -p $RPM_BUILD_ROOT%{_mandir}/$l/man1
  install -m 644 DOCS/man/mplayer.1.$l.utf8 $RPM_BUILD_ROOT%{_mandir}/$l/man1/mplayer.1
  install -m 644 DOCS/man/mplayer.1.$l.utf8 $RPM_BUILD_ROOT%{_mandir}/$l/man1/mencoder.1
done

# Clean up documentation
mkdir doc
cp -R DOCS/* doc/
rm -r doc/man
rm doc/README
mv doc/HTML/* doc/
rmdir doc/HTML

# Install the rest of the configuration files after making a few
# changes in them.
perl -pi -e 's/fs=yes/\# fs=yes/; s/\#\# Delete this default :\)/\#\#/; s|^include = .*|\#include = /home/me/.mplayer/something|; s|\# skin = default|skin = Blue|;' etc/example.conf
install -m 644 etc/input.conf $RPM_BUILD_ROOT%{_sysconfdir}/mplayer/input.conf
install -m 644 etc/menu.conf $RPM_BUILD_ROOT%{_sysconfdir}/mplayer/menu.conf
install -m 644 etc/example.conf $RPM_BUILD_ROOT%{_sysconfdir}/mplayer/mplayer.conf

# Fix permissions on default skin for gmplayer and install.
mkdir skins
tar -C skins -xjf %{SOURCE1}
find skins -type d -exec chmod 755 {} \;
find skins -type f -exec chmod 644 {} \;
find skins -type f -name "README" -exec rm {} \;
mkdir -p $RPM_BUILD_ROOT%{_datadir}/mplayer/Skin
cp -a skins/* $RPM_BUILD_ROOT%{_datadir}/mplayer/Skin/

# The icon used in the menu entry
install -D -m 644 Gui/mplayer/pixmaps/logo.xpm \
  $RPM_BUILD_ROOT%{_datadir}/pixmaps/mplayer-logo.xpm

mkdir -p $RPM_BUILD_ROOT%{_datadir}/applications
desktop-file-install --vendor livna \
  --dir $RPM_BUILD_ROOT%{_datadir}/applications \
  --add-category X-Livna \
  --add-category Application \
  --add-category AudioVideo \
  %{SOURCE3}

mkdir -p $RPM_BUILD_ROOT%{_libdir}/win32

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%post -n libpostproc -p /sbin/ldconfig

%postun -n libpostproc -p /sbin/ldconfig


%clean
rm -rf $RPM_BUILD_ROOT


%files
%defattr(-, root, root, -)
%doc AUTHORS ChangeLog doc/* LICENSE README
%dir %{_sysconfdir}/mplayer
%config(noreplace) %{_sysconfdir}/mplayer/mplayer.conf
%config(noreplace) %{_sysconfdir}/mplayer/input.conf
%config(noreplace) %{_sysconfdir}/mplayer/menu.conf
%{_bindir}/mplayer
%{_libdir}/libdha.so.*
%{_libdir}/mplayer
%dir %{_libdir}/win32
%dir %{_datadir}/mplayer
%{_mandir}/man1/mplayer.1*
%lang(de) %{_mandir}/de/man1/mplayer.1*
%lang(es) %{_mandir}/es/man1/mplayer.1*
%lang(fr) %{_mandir}/fr/man1/mplayer.1*
%lang(hu) %{_mandir}/hu/man1/mplayer.1*
%lang(pl) %{_mandir}/pl/man1/mplayer.1*
%lang(zh_TW) %{_mandir}/zh_TW/man1/mplayer.1*

%files gui
%defattr(-, root, root, -)
%{_bindir}/gmplayer
%{_datadir}/applications/*.desktop
%{_datadir}/pixmaps/*.xpm
%{_datadir}/mplayer/Skin

%files mencoder
%defattr(-, root, root, -)
%{_bindir}/mencoder
%{_mandir}/man1/mencoder.1*
%lang(de) %{_mandir}/de/man1/mencoder.1*
%lang(es) %{_mandir}/es/man1/mencoder.1*
%lang(fr) %{_mandir}/fr/man1/mencoder.1*
%lang(hu) %{_mandir}/hu/man1/mencoder.1*
%lang(pl) %{_mandir}/pl/man1/mencoder.1*
%lang(zh_TW) %{_mandir}/zh_TW/man1/mencoder.1*

%files -n libpostproc
%defattr(-, root, root, -)
%{_prefix}/include/*
%{_libdir}/libpostproc.so
%{_libdir}/libpostproc.so.*


%changelog
* Sun Jul  4 2004 Dams <anvil[AT]livna.org> 0:1.0-0.lvn.0.12.pre4
- Added patch to fix security issue in GUI
- Updated Blue Skin to version 1.4
- Added theora support build option (default disabled)

* Sun Jun 13 2004 Dams <anvil[AT]livna.org> 0:1.0-0.lvn.0.11.pre4
- Updated desktop entry

* Fri May 21 2004 Dams <anvil[AT]livna.org> 0:1.0-0.lvn.0.10.pre4
- mencoder requires mplayer/libpostproc same E:V-R

* Thu May 20 2004 Dams <anvil[AT]livna.org> 0:1.0-0.lvn.0.9.pre4
- Updated to 1.0pre4
- Minor changes due to version upgrade
- Updated Blue skin

* Sat Apr  3 2004 Dams <anvil[AT]livna.org> 0:1.0-0.lvn.0.8.pre3try2
- Updated version to fix exploitable remote buffer overflow
  vulnerability in the HTTP parser

* Tue Mar  2 2004 Dams <anvil[AT]livna.org> 0:1.0-0.lvn.0.7.pre3
- Specified libmatroska version in build dependency

* Sun Feb 29 2004 Dams <anvil[AT]livna.org> 0:1.0-0.lvn.0.6.pre3
- Added libmatroska support
- Added fix for matroska support build (from cvs)

* Wed Jan  7 2004 Marius L. Jøhndal <mariuslj at ifi.uio.no> 0:1.0-0.lvn.0.5.pre3
- Fixed broken documentation.
- Added Live.com support.
- Made ALSA support optional (for pre-FC1 builds).
- Converted spec file to UTF-8.

* Wed Dec 10 2003 Marius L. Jøhndal <mariuslj at ifi.uio.no> 0:1.0-0.lvn.0.4.pre3
- Enabled ALSA support.

* Tue Dec  9 2003 Marius L. Jøhndal <mariuslj at ifi.uio.no> 0:1.0-0.lvn.0.3.pre3
- Update to 1.0pre3.
- Added --disable-smb to avoid linking with Samba libraries.
- Updated to new documentation layout. Yet again.
- Simplified unpacking of skin.

* Fri Nov 21 2003 Marius L. Jøhndal <mariuslj at ifi.uio.no> 0:1.0-0.lvn.0.2.pre2
- Fixed typo (bug 6).

* Fri Nov 14 2003 Marius L. Jøhndal <mariuslj at ifi.uio.no> 0:1.0-0.lvn.0.1.pre2
- Update to 1.0pre2.
- Moved remaining font to mplayer-fonts; require mplayer-fonts.
- Added LICENSE file.
- Updated to new documentation layout.
- Added empty _libdir/win32 directory.
- s/fedora/livna/ and s/X-Fedora/X-Livna/ in desktop file.

* Sun Sep 28 2003 Dams <anvil[AT]livna.org> 0:0.92-0.fdr.1
- Updated to 0.92
- Removed comment after scriptlets

* Sat Aug 23 2003 Marius L. Jøhndal <mariuslj at ifi.uio.no> 0:0.91-0.fdr.2
- mplayer requires same epoch-version-release of libpostproc (bug 610).

* Sat Aug 16 2003 Marius L. Jøhndal <mariuslj at ifi.uio.no> 0:0.91-0.fdr.1
- Updated to 0.91 release.
- Updated Blue-1.0.tar.bz2 skin (upstream file changed!).
- Added playlist patch.
- Require xvidcore-devel >= 0:0.9.2 to get versioned libxvidcore.so.
- Convert all (non-English) manual pages to UTF-8 (bug 524).
- Removed codecs.conf. No longer needed.
- Removed outdated Polish documentation.

* Tue Jul 22 2003 Marius L. Jøhndal <mariuslj at ifi.uio.no> 0:0.90-0.fdr.13
- Updated to new upstream arial iso-8859-1 font.
- Fixed broken font installation (bug 495).

* Fri Jul 11 2003 Marius L. Jøhndal <mariuslj at ifi.uio.no> 0:0.90-0.fdr.12
- Fixed dangling font symlink (bug 257).

* Thu Jul 10 2003 Marius L. Jøhndal <mariuslj at ifi.uio.no> 0:0.90-0.fdr.11
- Disabled svgalib for reproducible builds (bug 257).
- Moved mplayer.desktop to source file (bug 257).

* Mon Jul  7 2003 Marius L. Jøhndal <mariuslj at ifi.uio.no> 0:0.90-0.fdr.10
- Disabled termcap for reproducible builds (bug 257).

* Sun Jul  6 2003 Marius Jøhndal <mariuslj at ifi.uio.no> 0:0.90-0.fdr.9
- Made packages own %{_libdir}/mplayer and %{_datadir}/mplayer/Skin.

* Sat Jun 21 2003 Marius Jøhndal <mariuslj at ifi.uio.no> 0:0.90-0.fdr.8
- configure patch and BuildRequires: glibc-kernheaders to enable V4L (bug 392).

* Fri Jun 20 2003 Marius Jøhndal <mariuslj at ifi.uio.no> 0:0.90-0.fdr.7
- Moved skins (except a default skin) to separate package (bug 257).
- Removed empty README file from Blue skin directory.
- A couple of %{_prefix}/lib to %{_libdir} fixes.
- Moved fonts (except a default font) to separate package.
- Removed /usr/bin/find and unzip from BuildRequires.

* Sat May  3 2003 Marius Jøhndal <mariuslj at ifi.uio.no> 0:0.90-0.fdr.6
- Added skins subpackage.
- %{buildroot} -> $RPM_BUILD_ROOT.
- Honour $RPM_OPT_FLAGS.
- BuildRequires: freetype-devel to enable TrueType subtitles.
- BuildRequires: libdv-devel for dv driver (bug 227).
- BuildRequires: liblzo-devel for lzo driver (bug 227).
- BuildRequires: libjpeg-devel for JPEG vo (bug 227).
- BuildRequires: libungif-devel for GIF vo (bug 227).
- BuildRequires: zlib-devel for zlib driver (bug 227).

* Mon Apr 21 2003 Marius Jøhndal <mariuslj at ifi.uio.no> 0:0.90-0.fdr.5
- BuildRequires: libmad -> libmad-devel.

* Thu Apr 17 2003 Warren Togami <warren@togami.com> 0:0.90-0.fdr.4
- BuildRequires libpng-devel

* Sat Apr 12 2003 Marius Jøhndal <mariuslj at ifi.uio.no> 0:0.90-0.fdr.3
- Changed default skin to Blue (which is the new offical default skin).
- Changed desktop file category to X-Fedora.
- Added faad2 support.
- Split libpostproc into separate package. This simplifies requirements for mencoder.
- Added BuildRequires libogg-devel.
- Removed codecs-in.html from documentation.
- Enabled OSD menus.

* Tue Apr  8 2003 Marius Jøhndal <mariuslj at ifi.uio.no> 0:0.90-0.fdr.2
- Patched libpostproc makefile to add missing symlink to versioned library.
- Temporarily disabled SMP make flags.
- Modified config files to avoid starting up in full-screen mode.

* Mon Apr  7 2003 Marius Jøhndal <mariuslj at ifi.uio.no> 0:0.90-0.fdr.1
- Updated to 0.90 release.
- Moved non-English manual pages into %{_mandir}.
- Expanded description.
- Added symlinks for mencoder manual pages.
- Moved default {input,menu,mplayer}.conf into /etc/mplayer.
- Added Chinese (traditional) manual page.
- Moved gui to separate package. Motivation: Get rid of default skin
  from mplayer package.
- Moved mencoder to separate package. By doing this, lame is no longer
  required by mplayer.
- Corrected a couple of typos in source URLs.
- Updated subtitle fonts.

* Fri Apr  4 2003 Marius Jøhndal <mariuslj at ifi.uio.no> 0:0.90-0.fdr.0.1.rc5
- Initial Fedora RPM release.

* Mon Mar 31 2003 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Rebuilt for Red Hat Linux 9.

* Mon Mar 24 2003 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Fix ppc build.

* Wed Mar 19 2003 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Update to 0.90rc5.

* Sat Mar 15 2003 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Added gcccheck build option.
- Added freedesktop build option.

* Sun Feb 16 2003 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Rebuild against new libdvdread.

* Wed Feb 12 2003 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Add a workaround for the default skin's permission problem.

* Mon Feb 10 2003 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Update to 0.90rc4.
- Updated default skin to 1.7.

* Wed Jan 22 2003 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Added --without dvdnav build option.

* Mon Jan 20 2003 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Update to 0.90rc3.
- Added "--without esd" build option.

* Sat Jan 11 2003 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Update to today's snapshot as it fixes many bugs (fullscreen for ex).
- Replace all divx4linux stuff with xvid.
- Rebuilt with libavcodec from ffmpeg, doh!

* Thu Jan  2 2003 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Update to 0.90rc2, updated the cdda patch too.
- Removed the Epoch... yes, upgrade manually by erasing and installing again.

* Mon Dec  9 2002 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Update to 0.90rc1.

* Fri Nov 15 2002 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Re-enabled the auto req/prov.

* Tue Nov 12 2002 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Update to 0.90pre10.
- Added CDDA support through cdparanoia + include fix.
- Enabled shared postproc library.
- Fixed VCD support by having redhat -> linux (probably fixes joystick too).
- Removed CFLAGS overwriting.

* Sat Oct 26 2002 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Fixed aa with --disable-aa instead of --disable-aalib.

* Fri Oct 25 2002 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Update to 0.90pre9.
- Enable ALSA by default now.
- Added patch to remove that awful startup message about runtime cpudetection.
- Added libdvdnav support for rebuild.

* Wed Oct  3 2002 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Enforced --without libdv, lirc options to disable even if libs are present.

* Sat Sep 28 2002 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Rebuilt for Red Hat Linux 8.0.
- Added new menu entry.
- New --with and --without rebuild options.

* Fri Sep 20 2002 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Update to 0.90pre8.
- Added some files to the %%doc section.

* Thu Sep  5 2002 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Update to 0.90pre7.
- Removed obsolete prefix.
- Explicitely disable ALSA for now.

* Mon Aug 20 2002 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Rebuilt with libdvdnav... but removed, just too experimental :-(
- Added direct DVD menu entry.

* Mon Aug 13 2002 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Added arts dependency.

* Tue Aug  6 2002 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Update to 0.90pre6.
- Added aalib and lirc build dependencies to get a full-featured binary.
- Updated %%description.
- Added iso-8859-2 font in the package.
- Cleaned up old unuseful hacks.

* Mon Jun 10 2002 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Update to 0.90pre5.

* Tue May 14 2002 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Update to 0.90pre4.
- Overwrite the absolute link for the mencoder.1 man page.

* Sat May 11 2002 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Added the mime types for the menu entry.

* Thu May  2 2002 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Added CFLAGS for configure and i18n.
- Rebuilt against Red Hat Linux 7.3.
- Added the %%{?_smp_mflags} expansion.

* Tue Apr 30 2002 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Update to 0.90pre2.
- Fixed the libGLcore.so.1 and lirc dependencies.
- Build with gcc 2.96 instead of gcc3.

* Fri Apr 26 2002 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Update to 0.90pre1, fully GPL at last! Here come the binary packages :-)

* Fri Feb  1 2002 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Update to today's current version.
- Added 3 skins + removed workaround since skin archives are fixed.

* Wed Jan  2 2002 Matthias Saou <matthias.saou@est.une.marmotte.net>
- %doc cleanup and update to today's build.
- Modified for the new CONFDIR stuff.

* Wed Dec 12 2001 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Initial RPM release.

